
#include <cairomm-1.0/cairomm/context.h>

#include "AnalogGauge.h"

#include <math.h>
#include <cairomm/context.h>
#include <cairomm/surface.h>
#include <string>
#include <iostream>
using namespace std;

// Define Methods
AnalogGauge::AnalogGauge(int gauge_ID, string NeedlePATH, double MinAng, double MaxAng, double NXpos, double NYpos, double MinVal, double MaxVal) {
	this->MinAng = MinAng;
	this->MaxAng = MaxAng;
	this->NXpos = NXpos;
	this->NYpos = NYpos;
	this->MinVal = MinVal;
	this->MaxVal = MaxVal;
	this->gauge_ID = gauge_ID;
        this->NeedlePATH = NeedlePATH;
        
        if(this->MinAng < this->MaxAng)
		CW = false;
	else 
		CW = true;
		
	CurrentVal = 0;
}

AnalogGauge::~AnalogGauge() {}

void AnalogGauge::Update(Cairo::RefPtr<Cairo::Context> CaiPointer, double NewValue) {
    double Nangle = 0;
    Cairo::RefPtr<Cairo::ImageSurface> image = Cairo::ImageSurface::create_from_png(NeedlePATH);
    cr = CaiPointer;
    cr->save();
   
   // Create image
    cr->set_source(image, NXpos, NYpos);
    width = image->get_width();
    height = image->get_height();
    cout << "Width = " << width << ", Height = " << height << endl;
    // compute the new angle in here
        if(CW) {
                cout << "clockwise\n";
                cout << "Max angle: " << MaxAng << endl;
                cout << "Min angle: " << MinAng << endl; 
                cout << "Max value: " << MaxVal << endl;
                cout << "Min value: " << MinVal << endl;
		Nangle = MinAng - (NewValue/MaxVal)*(MaxAng - MaxAng);
                cout << "New angle: " << Nangle << endl;
        }
        else {
            cout << "counter clockwise\n";
            cout << "Max angle: " << MaxAng << endl;
            cout << "Min angle: " << MinAng << endl;
            cout << "Max value: " << MaxVal << endl;
            cout << "Min value: " << MinVal << endl;
            Nangle = (NewValue/MaxVal) * MaxAng;	
        }
        
        cout << "The rotation angle for gauge " << this->gauge_ID << " is: " << Nangle << endl;
    
    //cr->rotate(Nangle*M_PI/180);
    cr->rotate_degrees(Nangle);
    double y = width*cos(Nangle*M_PI/180);
    double x = width*sin(Nangle*M_PI/180);
    cr->move_to(NXpos+x, NYpos+y);
    CurrentVal = NewValue;
    cout << "The current value of gauge " << this->gauge_ID<< " is: " << CurrentVal << "\n\n";
    
    cr->paint();
    cr->restore();
}

void AnalogGauge::init(Cairo::RefPtr<Cairo::Context> CaiPointer) {
    this->Update(CaiPointer, CurrentVal);
}

int AnalogGauge::getID(void) const {return gauge_ID;}
