#ifndef DASHBOARD_H
#define DASHBOARD_H

#include "Scene_Template.h"
#include "Default.h"
#include "Scene.h"

#include "Gauge.h"
#include "AnalogGauge.h"
#include "TextualGauge.h"
#include "QueueDataObject.h"
//#include "ECUScan.h"
#include "DataLogger.h"

#include <cairomm/context.h>
#include <gtkmm/drawingarea.h>
#include <queue>
#include <time.h>
#include <list>
#include <vector>

class Dashboard : public Gtk::DrawingArea {
  private:
    // Methods
    void changeScene(int Scene_ID);
    void BuildInterface();
    void init();
    bool UpdateInterface();
    bool FileExists(std::string);
    bool checkFileType(std::string, std::string);
    std::string UptoLower(std::string);
    virtual bool on_expose_event(GdkEventExpose* event);
    
    // Global Variables
    double sensor_value, totalDrawableWidth, totalDrawableHeight;
    bool initialize;
    int Gauge_ID, nScenes;
    Cairo::RefPtr<Cairo::Context> cr;
    Glib::RefPtr<Glib::IOChannel> file_read;
    std::list <Scene_Template *> Scenes;
    Scene_Template *currentScene;
    std::queue <QueueDataObject> drawQueue;
    QueueDataObject *tempInfo;
    tm *currentTime;
    //Diagnostic *MessageCenter
    //ECUScan *EcuScan;
    DataLogger *data_logger;
    
  public:
    Dashboard(void);
    virtual ~Dashboard(void);
};
#endif