#include "Scene.h"

#include <string>
#include <iostream>
#include <cairomm/context.h>
using namespace std;

Scene::Scene(int SceneID, string SceneName, int nGauges, list <Gauge *> Gauges, string bgImage) {
    this->SceneID = SceneID;
    this->SceneName = SceneName;
    this->nGauges = nGauges;
    this->Gauges = Gauges;
    this->bgImage = bgImage;
}

Scene::~Scene() {
}

void Scene::Update(Cairo::RefPtr<Cairo::Context> caiPointer, int gauge_ID, double sensor_value) {
    cr = caiPointer;
    //cr->save();
    
    // Draw background image
    cr->save();
    Cairo::RefPtr<Cairo::ImageSurface> image = Cairo::ImageSurface::create_from_png(bgImage);
    cr->create(image);
    cr->set_source(image, NXpos, NYpos);
    cr->paint();
    cr->restore();
    // Done drawing background image
    
    list <Gauge *>::iterator It;
    for(It=Gauges.begin(); It!=Gauges.end(); It++) {
        cr->save();
        if((*It)->getID() == gauge_ID) { 
            cout << "Found gauge " << (*It)->getID() << " now updating it\n";
            (*It)->Update(cr, sensor_value);
        }
        else
            (*It)->init(cr);
        cr->restore();
    }
    //cr->restore();
}

void Scene::init(Cairo::RefPtr<Cairo::Context> CaiPointer) {
    cr = CaiPointer;
    cr->save();
    Cairo::RefPtr<Cairo::ImageSurface> image = Cairo::ImageSurface::create_from_png(bgImage);
    cr->create(image);
    cr->set_source(image, NXpos, NYpos);
    cr->paint();
    cr->restore();
    list <Gauge *>::iterator It;
    for(It=Gauges.begin(); It!=Gauges.end(); It++) {
        (*It)->init(cr);
    }
}

void Scene::setScreenSize(double width, double height) {} // does not need to be used for this object

int Scene::getID() {return SceneID;}